# Boosted Decision Trees                                                                                                                                                                                   
Boosted decision trees (BDTs) are sets of decision trees where each tree is dependent on prior trees.The BDTs implemented in mva-trainer are based on the [scikit-learn GradientBoostingClassifier class](https://scikit-learn.org/stable/modules/generated/sklearn.ensemble.GradientBoostingClassifier.html)
It is built stage-wise and provides an ensemble of weak learners.
When combined with previous models, the ensemble assumes that the best possible next model minimises the overall loss or prediction error.
During training, each new model follows the negative gradient of the loss in the space of possible predictions for each training case, minimising the prediction error.

# Building a BDT

In mva-trainer the architecture of a BDT is steered by the following parameters:

* nEstimators
* MaxDepth
* MaxFeatures
* MinSamplesSplit
* MinSamplesLeaf

See the settings for explanations of these parameters.

# Hyperparameter optimisation

Hyperparameter optimisation can also be performed for BDTs in mva-trainer.
However, since the model in question is already an ensemble model, the optimised parameters will likely not improve the models performance significantly.
The following parameters steer the hyperparameter optimisation:

* MaxDepth
* MaxFeatures

Here these values are taking as maximum values in the random initialisation.
This means that new configs are assigned a random value between 1 and the defined value.

To run hyperparameter optimisation you can again use the `Optimise.py` script.
```sh
./scripts/Optimise.py -c <config_path> -cp <HTCondorConfig_path> --RunOption <RunOption> --NNetworks <NNetworks> --RandomSeed <RandomSeed>
```

For an explanation of the options check the DNN optimisation section.